`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 11/25/2023 11:27:26 AM
// Design Name: 
// Module Name: floating_point_fsm
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module booth_mul_test();
    reg [7:0] op1_test;
    reg [7:0] op2_test;
    reg [15:0]  result_exp;
    wire [15:0] result_test;
    
    parameter error_limit = 5;  //Limit the number of errors shown
    
    reg[8:0] op1_it;
    reg[8:0] op2_it;
    reg[7:0] error_count;
    
    booth_mul mul(
        .op1(op1_test),
        .op2(op2_test),
        .result(result_test)
    );
    
    initial begin
         op1_test = 0;
         op2_test = 0;
         error_count = 0;
         #100;
         
         $display("There are 2^16 combinations tested, it might take some time...");
         
         for( op1_it = 0; op1_it < 2**8; op1_it = op1_it + 1 ) begin
            for( op2_it = 0; op2_it < 2**8; op2_it = op2_it + 1 ) begin
                op1_test = op1_it;
                op2_test = op2_it;
                result_exp = op1_it * op2_it;
                
                #5;
                
                if(result_test !== result_exp) begin
                    $display(" %d * %d value mismatch: expected %b, actual %b", op1_it, op2_it, result_exp, result_test);
                    
                    error_count = error_count + 1;
                end
                
                if(error_count > error_limit)
                    $stop;
                
                #5;
            end
        end
        
        $stop;
        
        if(error_count == 0)
            $display("Test ended succesfully");
        else
            $display("Test fail succesfully with %d errors", error_count);
                
         
    end
    
endmodule