`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 11/25/2023 11:27:26 AM
// Design Name: 
// Module Name: floating_point_fsm
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 1 4 7
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module floating_point_fsm(
        input clk,
        input rst,
        input en,           /*Enable the read for a and b in the next cycle*/
        input [11:0] a,     /*First operand, expressed in S_EEEE_MMMMMMM format*/
        input [11:0] b,     /*2nd   operand, expressed in S_EEEE_MMMMMMM format*/
        output reg   done,  /*Enables the output; shall be 1 when out is ready*/
        output[11:0] out    /*The result expressed in S_EEEE_MMMMMMM format*/
    );
        
    //control signals for A register
    reg         a_we, a_oe;
    wire [11:0] a_out;
    
    //control signals for B register
    reg         b_we, b_oe;
    wire [11:0] b_out;
    
    //control signals for MUL register
    reg         mul_we, mul_oe;
    wire [15:0] mul_out;  
    wire [15:0] mul_result;
    
    //control signals for RES register
    reg         res_we, res_oe;
    reg [11:0]  res_in;
    
    //state registers
    reg [3:0]   state, next_state; 
    
    //registers to save the input and the output
    register #(12) A   (.clk(clk), .rst(rst), .in(a),      .we(a_we),   .oe(a_oe),   .out(a_out));
    register #(12) B   (.clk(clk), .rst(rst), .in(b),      .we(b_we),   .oe(b_oe),   .out(b_out));
    register #(12) RES (.clk(clk), .rst(rst), .in(res_in), .we(res_we), .oe(res_oe), .out(out));
    
    //internal registers, used to save temporary result
    register #(16) MUL (.clk(clk), .rst(rst), .in(mul_result), .we(mul_we), .oe(mul_oe), .out(mul_out));
    
    //TODO: instantiate the booth multiplication module, and connect corresponding wires to multiply the mantisse
    
    //TODO: sequencial logic for the state variable, which is reset aware
    
    always@(*) begin
        //All the output signals are initialized with 0; TODO: if you add/use extra variables, add them here
        //You can't remove the initalization - this will transform the wires in asynchronus memory elements
        a_we = 0;
        a_oe = 0;
        b_we = 0;
        b_oe = 0;
        mul_we = 0;
        mul_oe = 0;
        res_we = 0;
        res_oe = 0;
        res_in = 0;
        done = 0;
        
        //TODO: implement the state machine
        
    end
endmodule
